# $Revision: 1.33 $, $Date: 2011/08/09 17:10:10 $
#
# Conditional build:
%bcond_without	lua	# Lua (5.1) bindings
%bcond_without	perl	# Perl bindings
%bcond_without	python	# Python bindings (required by prewikka)
%bcond_without	ruby	# Ruby bindings
#
%include	/usr/lib/rpm/macros.perl
Summary:	The Prelude library
Summary(pl.UTF-8):	Biblioteka Prelude
Name:		libprelude
Version:	1.0.0
Release:	1
License:	GPL v2 or commercial
Group:		Libraries
#Source0Download: http://www.prelude-ids.com/developpement/telechargement/index.html
Source0:	http://www.prelude-ids.com/download/releases/libprelude/%{name}-%{version}.tar.gz
# Source0-md5:	a5bb76538d240e5fac5f6ab0b7fabfe5
Patch0:		%{name}-libtool.patch
Patch1:		%{name}-ruby.patch
URL:		http://www.prelude-ids.com/
BuildRequires:	autoconf >= 2.59
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	gnutls-devel >= 1.0.17
BuildRequires:	gtk-doc >= 1.0
BuildRequires:	libgcrypt-devel >= 1.1.94
BuildRequires:	libltdl-devel >= 2:2.0
BuildRequires:	libstdc++-devel
BuildRequires:	libtool >= 2:2.0
%{?with_lua:BuildRequires:	lua51-devel >= 5.1}
%{?with_perl:BuildRequires:	perl-devel}
%{?with_python:BuildRequires:	python-devel >= 1:2.5}
BuildRequires:	rpm-perlprov
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.219
%{?with_ruby:BuildRequires:	ruby-devel >= 1.9}
BuildRequires:	sed >= 4.0
%{?with_perl:BuildRequires: swig-perl}
%{?with_python:BuildRequires: swig-python}
%{?with_ruby:BuildRequires: swig-ruby}
Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Prelude library is a collection of generic functions providing
communication between the Prelude Hybrid IDS suite components. It
provides a convenient interface for sending alerts to Prelude Manager
with transparent SSL, failover and replication support, asynchronous
events and timer interfaces, an abstracted configuration API (hooking
at the commandline, the configuration line, or wide configuration,
available from the Manager), and a generic plugin API. It allows you
to easily turn your favorite security program into a Prelude sensor.

%description -l pl.UTF-8
Biblioteka Prelude to zbiór ogólnych funkcji zapewniających
komunikację pomiędzy komponentami zestawu Prelude Hybrid IDS.
Dostarcza wygodny interfejs do wysyłania alarmów do zarządcy Prelude z
przezroczystą obsługę SSL, failover i replikacji, interfejsy do
zdarzeń asynchronicznych i zegarów, abstrakcyjne API konfiguracyjne
(obsługujące linię poleceń, linię konfiguracji i konfigurację dostępną
z zarządcy) oraz ogólne API wtyczek. Pozwala łatwo zamienić ulubiony
program związany z bezpieczeństwem na czujnik Prelude.

%package libs
Summary:	The Prelude library
Summary(pl.UTF-8):	Biblioteka Prelude
Group:		Libraries
Requires:	gnutls >= 1.0.17
Requires:	libgcrypt >= 1.1.94

%description libs
The Prelude library.

%description libs -l pl.UTF-8
Biblioteka Prelude.

%package devel
Summary:	Header files and development documentation for libprelude
Summary(pl.UTF-8):	Pliki nagłówkowe i dokumentacja programistyczna dla libprelude
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	gnutls-devel >= 1.0.17
Requires:	libgcrypt-devel >= 1.1.94
Requires:	libltdl-devel

%description devel
Header files and development documentation for libprelude.

%description devel -l pl.UTF-8
Pliki nagłówkowe i dokumentacja programistyczna dla libprelude.

%package static
Summary:	Static libprelude library
Summary(pl.UTF-8):	Statyczna biblioteka libprelude
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libprelude library.

%description static -l pl.UTF-8
Statyczna biblioteka libprelude.

%package c++
Summary:	libpreludecpp - C++ binding for libprelude
Summary(pl.UTF-8):	libpreludecpp - wiązanie C++ do libprelude
Group:		Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description c++
libpreludecpp - C++ binding for libprelude.

%description c++ -l pl.UTF-8
libpreludecpp - wiązanie C++ do libprelude.

%package c++-devel
Summary:	Header file for libpreludecpp library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libpreludecpp
Group:		Development/Libraries
Requires:	%{name}-c++ = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	libstdc++-devel

%description c++-devel
Header file for libpreludecpp library - C++ binding for libprelude.

%description c++-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki libpreludecpp - wiązań C++ do libprelude.

%package c++-static
Summary:	Static libpreludecpp library
Summary(pl.UTF-8):	Statyczna biblioteka libpreludecpp
Group:		Development/Libraries
Requires:	%{name}-c++-devel = %{version}-%{release}

%description c++-static
Static libpreludecpp library.

%description c++-static -l pl.UTF-8
Statyczna biblioteka libpreludecpp.

%package -n lua-prelude
Summary:	PreludeEasy - libprelude Lua bindings
Summary(pl.UTF-8):	PreludeEasy - dowiązania języka Lua do libprelude
Group:		Development/Languages
Requires:	%{name}-c++ = %{version}-%{release}

%description -n lua-prelude
PreludeEasy - libprelude Lua bindings.

%description -n lua-prelude -l pl.UTF-8
PreludeEasy - dowiązania języka Lua do libprelude.

%package -n perl-libprelude
Summary:	Prelude Perl module - low-level Perl binding for libprelude
Summary(pl.UTF-8):	Moduł Perla Prelude - niskopoziomowe wiązanie Perla do libprelude
Group:		Development/Languages/Perl
Requires:	%{name}-libs = %{version}-%{release}

%description -n perl-libprelude
Prelude Perl module - low-level Perl binding for libprelude.

%description -n perl-libprelude -l pl.UTF-8
Moduł Perla Prelude - niskopoziomowe wiązanie Perla do libprelude.

%package -n perl-PreludeEasy
Summary:	PreludeEasy - high-level Perl binding for libprelude
Summary(pl.UTF-8):	PreludeEasy - wysokopoziomowe wiązanie Perla do libprelude
Group:		Development/Languages/Perl
Requires:	%{name}-c++ = %{version}-%{release}

%description -n perl-PreludeEasy
PreludeEasy - high-level Perl binding for libprelude.

%description -n perl-PreludeEasy -l pl.UTF-8
PreludeEasy - wysokopoziomowe wiązanie Perla do libprelude.

%package -n python-libprelude
Summary:	Low-level Python binding for libprelude
Summary(pl.UTF-8):	Niskopoziomowe wiązanie Pythona do libprelude
Group:		Development/Languages/Python
Requires:	%{name}-libs = %{version}-%{release}

%description -n python-libprelude
Low-level Python binding for libprelude.

%description -n python-libprelude -l pl.UTF-8
Niskopoziomowe wiązanie Pythona do libprelude.

%package -n python-PreludeEasy
Summary:	PreludeEasy - high-level Python binding for libprelude
Summary(pl.UTF-8):	PreludeEasy - wysokopoziomowe wiązanie Pythona do libprelude
Group:		Development/Languages/Python
Requires:	%{name}-c++ = %{version}-%{release}

%description -n python-PreludeEasy
PreludeEasy - high-level Python binding for libprelude.

%description -n python-PreludeEasy -l pl.UTF-8
PreludeEasy - wysokopoziomowe wiązanie Pythona do libprelude.

%package -n ruby-prelude
Summary:	PreludeEasy - libprelude Ruby bindings
Summary(pl.UTF-8):	PreludeEasy - dowiązania języka Ruby do libprelude
Group:		Development/Languages
Requires:	%{name}-c++ = %{version}-%{release}

%description -n ruby-prelude
PreludeEasy - libprelude Ruby bindings.

%description -n ruby-prelude -l pl.UTF-8
PreludeEasy - dowiązania języka Ruby do libprelude.

%prep
%setup -q
%patch0 -p1

%if %{with python}
# regenerate with fresh swig for gcc 4.6+
%{__rm} bindings/python/{_PreludeEasy.cxx,PreludeEasy.py}
%endif
%if %{with ruby}
# same for ruby 1.9
%{__rm} bindings/ruby/PreludeEasy.cxx
%patch1 -p1
%endif

sed -i -e 's/lua >= 5.1/lua51 >= 5.1/' configure.in

%build
%{__libtoolize}
%{__aclocal} -I m4 -I libmissing/m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--enable-gtk-doc \
	--enable-static \
	--with%{!?with_lua:out}-lua \
	--with%{!?with_perl:out}-perl \
	--with%{!?with_python:out}-python \
	--with-html-dir=%{_gtkdocdir}/libprelude \
	--with-perl-installdirs=vendor

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%if %{with perl}
# missing from make install
[ ! -f $RPM_BUILD_ROOT%{perl_vendorarch}/PreludeEasy.pm ] || exit 1
cp -p bindings/perl/PreludeEasy.pm $RPM_BUILD_ROOT%{perl_vendorarch}
%endif
%if %{with lua}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/PreludeEasy.{la,a}
%endif
%if %{with python}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean
%endif
%if %{with ruby}
%{__rm} $RPM_BUILD_ROOT%{ruby_sitearchdir}/PreludeEasy.{la,a}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%post	c++ -p /sbin/ldconfig
%postun	c++ -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog LICENSE.README NEWS README
%attr(755,root,root) %{_bindir}/prelude-adduser
%attr(755,root,root) %{_bindir}/prelude-admin
%dir %{_sysconfdir}/prelude
%dir %{_sysconfdir}/prelude/default
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/prelude/default/client.conf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/prelude/default/global.conf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/prelude/default/idmef-client.conf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/prelude/default/tls.conf
%dir %{_sysconfdir}/prelude/profile
%{_mandir}/man1/prelude-admin.1*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libprelude.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libprelude.so.2

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/libprelude-config
%attr(755,root,root) %{_libdir}/libprelude.so
%{_libdir}/libprelude.la
%dir %{_includedir}/libprelude
%{_includedir}/libprelude/*.h
%{_aclocaldir}/libprelude.m4
%{_gtkdocdir}/libprelude
%{_pkgconfigdir}/libprelude.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libprelude.a

%files c++
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpreludecpp.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpreludecpp.so.0

%files c++-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpreludecpp.so
%{_libdir}/libpreludecpp.la
%{_includedir}/libprelude/idmef*.hxx
%{_includedir}/libprelude/prelude*.hxx

%files c++-static
%defattr(644,root,root,755)
%{_libdir}/libpreludecpp.a

%if %{with lua}
%files -n lua-prelude
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/PreludeEasy.so
%endif

%if %{with perl}
%files -n perl-libprelude
%defattr(644,root,root,755)
%{perl_vendorarch}/Prelude.pm
%dir %{perl_vendorarch}/auto/Prelude
%{perl_vendorarch}/auto/Prelude/Prelude.bs
%attr(755,root,root) %{perl_vendorarch}/auto/Prelude/Prelude.so

%files -n perl-PreludeEasy
%defattr(644,root,root,755)
%{perl_vendorarch}/PreludeEasy.pm
%dir %{perl_vendorarch}/auto/PreludeEasy
%{perl_vendorarch}/auto/PreludeEasy/PreludeEasy.bs
%attr(755,root,root) %{perl_vendorarch}/auto/PreludeEasy/PreludeEasy.so
%endif

%if %{with python}
%files -n python-libprelude
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/_prelude.so
%{py_sitedir}/prelude.py[co]
%{py_sitedir}/prelude-%{version}-py*.egg-info

%files -n python-PreludeEasy
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/_PreludeEasy.so
%{py_sitedir}/PreludeEasy.py[co]
%{py_sitedir}/PreludeEasy-%{version}-py*.egg-info
%endif

%if %{with ruby}
%files -n ruby-prelude
%defattr(644,root,root,755)
%attr(755,root,root) %{ruby_sitearchdir}/PreludeEasy.so
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: libprelude.spec,v $
Revision 1.33  2011/08/09 17:10:10  qboosh
- separated c++ bindings, split perl/python into low-level and PreludeEasy (the latter require libprelude-c++)

Revision 1.32  2011/08/09 15:42:20  qboosh
- enhanced ruby patch with more changes needed for 1.9; package ruby binding

Revision 1.31  2011/08/07 17:53:08  qboosh
- refresh PreludeEasy python binding from SWIG sources (needed for gcc 4.6+)
- package perl PreludeEasy plugin
- package lua binding
- some work on ruby binding (not finished, not ready for ruby 1.9)

Revision 1.30  2011/08/03 09:56:15  paszczus
- updated to 1.0.0

Revision 1.29  2010/07/09 11:18:57  arekm
- release 3

Revision 1.28  2010/06/06 13:35:22  arekm
- release 2

Revision 1.27  2009/09/03 14:54:05  tommat
- rel 1

Revision 1.26  2009/09/03 11:03:03  tommat
- up to 0.9.24.1
- adapterized

Revision 1.25  2009/03/14 12:07:58  hawk
- release 2

Revision 1.24  2008/11/15 19:44:46  arekm
- up to 0.9.21.3

Revision 1.23  2008/09/07 19:00:46  adamg
- release 2 (against libltdl-2.2.6-1)

Revision 1.22  2008/07/16 20:43:46  qboosh
- updated to 0.9.17.2
- updated URLs
- updated libdir patch

Revision 1.21  2008/05/26 20:38:56  hawk
- release 2

Revision 1.20  2008-03-24 16:51:56  qboosh
- updated to 0.9.16.2
- added libdir path to avoid using -L/lib
- proper perl module installation
- devel deps

Revision 1.19  2008-02-24 23:52:39  glen
- release 3

Revision 1.18  2008-01-16 17:36:28  arekm
- rel 2

Revision 1.17  2007-02-13 06:46:51  glen
- tabs in preamble

Revision 1.16  2007/02/12 00:49:03  baggins
- converted to UTF-8

Revision 1.15  2007/01/14 20:44:22  qboosh
- restored .la for shared lib(s); if it generates wrong deps, then linking is wrong

Revision 1.14  2007/01/14 19:44:36  qboosh
- bcond descs

Revision 1.13  2007/01/09 13:21:34  alucard
- unified

Revision 1.12  2007/01/08 14:23:06  alucard
- version up and build fixes

Revision 1.11  2007/01/06 20:26:05  arekm
- up from Tomasz Rutkowski

Revision 1.10  2007/01/05 17:57:19  arekm
- up to 0.9.12 by Tomasz Rutkowski

Revision 1.9  2006/05/16 11:06:11  mguevara
- 0.9.8-1

Revision 1.8  2006/04/11 15:43:33  mguevara
- 0.9.7.2 rel 1

Revision 1.7  2005/10/30 23:56:42  glen
- 0.9.0 release

Revision 1.6  2005/07/20 06:00:13  ankry
- kill caps, tabs

Revision 1.5  2005/07/12 20:11:08  qboosh
- pl, cleanup

Revision 1.4  2005/07/12 11:59:07  baggins
- release 2

Revision 1.3  2005/07/12 11:58:48  baggins
- devel Req: gnutls-devel

Revision 1.2  2005/07/11 16:48:25  arekm
- BR gnutls 1.2.5

Revision 1.1  2005/07/10 19:19:37  arekm
- initial pld release
